{ jIDEE : Java IDE for Education

  Copyright (C) 2010 Mithat Konar mkonar@dogus.edu.tr (except as noted)

  This source is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 3 of the License, or (at your option)
  any later version.

  This code is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
  details.

  A copy of the GNU General Public License is available on the World Wide Web
  at <http://www.gnu.org/copyleft/gpl.html>. You can also obtain it by writing
  to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
  MA 02111-1307, USA.
}

unit MiscUtils;

{$mode objfpc}{$H+}

interface

uses
{$IFDEF MSWINDOWS}
  Windows,
{$ENDIF}
  Classes, SysUtils;

function tiGetUserName : string;
function GetFSRoot() : String;

implementation

{ This tiGetUserName is assumed to be published under the GPL v2 or v3 and (C)2006 Graeme Geldenhuys }
{ From: http://www.mail-archive.com/lazarus@miraclec.com/msg06709.html }
{ Modifed (as marked) by mfk, 21 June - 15 Aug 2010. }
{$IFDEF MSWINDOWS}
function tiGetUserName : string;
var userNameBuffer : array[0..255] of char;
    sizeBuffer : DWord;
begin
  SizeBuffer := 256;
  getUserName(userNameBuffer, sizeBuffer);
  result := string(userNameBuffer);
end;
{$ELSE}
{$IFDEF UNIX}
function tiGetUserName : string;
begin
  Result := GetEnvironmentVariable('USERNAME');
  if Result = '' then
    Result := GetEnvironmentVariable('USER');
end;
{$ENDIF}
{$ENDIF}

function GetFSRoot() : String;
{ Returns the root of the file system in system coding (i.e., as with the RTL,
  not using UTF8. On MSWindows this should return the drive letter stored in the
  %SystemDrive% environment variable; on Unix it will return /; it returns a
  blank string for other systems. }
begin
{$IFDEF MSWINDOWS}
  result := GetEnvironmentVariable('SystemDrive')+DirectorySeparator;
{$ELSE}
  {$IFDEF UNIX}
  result := '/';
  {$ELSE}
  result := '';
  {$ENDIF}
{$ENDIF}
end;

end.

